package _VisualDVM.Passes.Sapfor;
import _VisualDVM.ComponentsServer.Component.Sapfor.Sapfor;
import _VisualDVM.Global;
import _VisualDVM.Passes.PassCode;
import _VisualDVM.Passes.Project.CurrentProjectPass;
import _VisualDVM.ProjectData.Files.DBProjectFile;
import _VisualDVM.ProjectData.SapforData.Variants.ParallelVariant;
public abstract class VariantsMassPass extends CurrentProjectPass {
    int count;
    public abstract PassCode getSubPassCode();
    @Override
    protected boolean needsAnimation() {
        return true;
    }
    @Override
    public void Interrupt() throws Exception {
        Global.mainModule.getSapfor().Interrupt();
    }
    @Override
    protected boolean canStart(Object... args) throws Exception {
        count = 0;
        if (super.canStart(args)) {
            count = target.parallelVariants.getUI().getSelectedCount();
            if (count == 0) {
                Log.Writeln_("Не выбрано ни одного параллельного варианта");
                return false;
            } else if (!Global.mainModule.getPass(PassCode.SPF_GetArrayDistribution).isDone()) {
                Log.Writeln_("Варианты неактуальны. Сначала перестройте распределение данных.");
                return false;
            }
            return true;
        }
        return false;
    }
    protected void body() throws Exception {
        ShowProgress(count, 0, true);
        int i = 0;
        for (ParallelVariant p : target.parallelVariants.Data.values())
            if (p.isSelected()) {
                if (!Global.mainModule.getPass(getSubPassCode()).Do(p)) break;
                ShowProgress(count, ++i, true);
            }
    }
    @Override
    protected void performFinish() throws Exception {
        //распаковку соо делаем только 1 раз. после всей массы вариантов.
        Sapfor sapfor = Global.mainModule.getSapfor();
        target.unpackMessagesAndLog(sapfor.getOutputMessage(), sapfor.getOutput());
    }
    @Override
    protected void showFinish() throws Exception {
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().RefreshVariants();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().RefreshProjectFiles();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().ShowProjectSapforLog();
        //-
        DBProjectFile badFile = target.getFirstBadFile();
        if (badFile != null) {
            Global.mainModule.getPass(PassCode.OpenCurrentFile).Do(badFile);
            Global.mainModule.getUI().getMainWindow().FocusProject();
            Global.mainModule.getUI().getMainWindow().getProjectWindow().FocusFile();
        }
        //-
        if (Global.mainModule.HasFile())
            Global.mainModule.getFile().form.ShowMessages();
    }
}
